// C Source File
// Created 11/24/00; 7:36:53 PM

// Available Patches
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
#define USE_INITS_PATCH

#define OPTIMIZE_ROM_CALLS // Use Speed Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

int _ti89;                    // Produce .89Z File

#define MAX_VOCAB_ENTRIES  1500
	// this is the maximum number of vocab entries in a file, because only
	// this many offsets will be allocated


unsigned int entrymatch(char *entryptr, char stringbuffer[]);
int GetUserInput(void);
char *GetInputString(int x, int y);
void EntryScreen(void);

typedef struct {
	int x;
	int y;
} POSITION;

// Main Function
void _main(void)
{
	HSym file;
	SYM_ENTRY *sym_entry;
	unsigned int size;
	char *vocabptr;
	unsigned int *entry_offset = NULL;
	unsigned int counter;
	unsigned int vocabcounter = 0;
	char *entryptr;
	char promptstring[] = "Word to Search For: ";
	char *userinputstring;
	POSITION input_position, output_entry_position;
	char filename[14] = "\0dict\\vocab_a\0";
	char width[2] = "a";

	EntryScreen();
	clrscr();
	FontSetSys(F_4x6);
	SetCurClip (&(SCR_RECT){{0, 0, 159, 99}});
	
	input_position.y = 0;
	input_position.x = DrawStrWidth(promptstring, F_4x6); 
	DrawStr(0, 0, promptstring, A_NORMAL);
	entry_offset = malloc(2 * MAX_VOCAB_ENTRIES);
while(1)
{
	userinputstring =	GetInputString(input_position.x, input_position.y);
	if (userinputstring[0] == '\0') break;
	
	ScrRectFill(&(SCR_RECT){{0, 12, 159, 94}}, ScrRect, A_REVERSE);

	output_entry_position.x = 0;
	output_entry_position.y = 12;
	
	filename[12] = userinputstring[0];
	file = SymFind(filename + 13);
		if(file.folder == 0)
		{
			DrawStr(0, 12, "The following file does not exist:", A_NORMAL);
			DrawStr(0, 18, &(filename[1]), A_NORMAL);
		}
	sym_entry = DerefSym(file);
	vocabptr = HeapDeref(sym_entry->handle);
	vocabptr += 3;                          // skip over size of file and 0 bit
	((char *) (&size))[0] = *vocabptr++;		// get the number of entries in the file
	((char *) (&size))[1] = *vocabptr++;
	
	vocabcounter = 0;
	for(counter = 1; counter <= size; counter++)
	{

		entry_offset[counter-1] = vocabcounter;
		while(*vocabptr != '\n' && *vocabptr != '\0')
		{	
			vocabptr++;
			vocabcounter++;
		}
		vocabptr++;
		vocabcounter++;
	}

	output_entry_position.x = 0;
	output_entry_position.y = 12;

	vocabptr = HeapDeref(sym_entry->handle);
	vocabptr += 5;
	for(counter = 1; counter <= size; counter++)
	{
		entryptr = vocabptr + entry_offset[counter-1];
		if(entrymatch(entryptr, userinputstring) == TRUE)
		{
			while(*(entryptr) != '\n' && *(entryptr) != '\0')
			{
				width[0] = *(entryptr);
				if(output_entry_position.x > 155)
				{
					output_entry_position.x = 0;
					output_entry_position.y += 6;
					if(output_entry_position.y > 88) break;
				}
				DrawChar(output_entry_position.x, output_entry_position.y, width[0], A_NORMAL);
				output_entry_position.x += DrawStrWidth(width, F_4x6);
				entryptr++;
			}
			output_entry_position.y +=9;
			output_entry_position.x = 0;
			if (output_entry_position.y > 88) break;
		}
	}
	
	//ngetchx();

}
free(entry_offset);
}

unsigned int entrymatch(char *entryptr, char stringbuffer[])
{
	int counter = 0;
	int counter2;
	while(stringbuffer[counter] != '\0')
	{
		counter++;
	}

	for (counter2 = 0; counter2 < counter; counter2++)
	{
		if(entryptr[counter2] != stringbuffer[counter2] && entryptr[counter2] - 32 != stringbuffer[counter2])
		{  
			return FALSE;
		}
	}
	return TRUE;
}

int GetUserInput() 
{
  void *kbq = kbd_queue();
  int key;

  OSTimerRestart(APD_TIMER);

  while (1) 
  {
    if (OSdequeue(&key, kbq) == FALSE) return key;
    if (OSTimerExpired(APD_TIMER)) off();    
  }
}

char *GetInputString(int x, int y)
{
	unsigned int key;
	static char stringbuffer[] = "\0nnnnnnnnnnnn";
	unsigned int number_of_characters = 0;

	DrawStr(x, y, stringbuffer, A_XOR); // erases the previous string when first called
	stringbuffer[0] = '\0';
	while(1)
	{
		key = GetUserInput();
		if(key == KEY_ENTER && number_of_characters > 0)
		{
			return stringbuffer;
		}
		else if (key == KEY_ESC || key == KEY_F5)
		{
			stringbuffer[0] = '\0';
			return stringbuffer;
		}
		else if (key == KEY_CLEAR)
		{
			DrawStr(x, y, stringbuffer, A_XOR); // erases the input
			stringbuffer[0] = '\0';
			number_of_characters = 0;
		}
		else if (key == KEY_BACKSPACE)
		{
			DrawStr(x, y, stringbuffer, A_XOR); // erases the input
			number_of_characters--;
			stringbuffer[number_of_characters] = '\0';
			DrawStr(x, y, stringbuffer, A_NORMAL);
		}
		else if ((key >='a' && key <= 'z') || (key >= 'A' && key <= 'z') || key == ' ')
		{
			stringbuffer[number_of_characters] = key;
			number_of_characters++;
			if (number_of_characters > 40) number_of_characters--;
			stringbuffer[number_of_characters] = '\0';
			DrawStr(x, y, stringbuffer, A_NORMAL);
		}
		else if (key == KEY_ON || key == KEY_OFF)
		{
			off();
		}
	}	
}

void DrawStrCentered(int y, char *string, int fontsize)
{
	int width;
	width = DrawStrWidth(string, fontsize);
	FontSetSys(fontsize);
	DrawStr(79 - width / 2, y, string, A_NORMAL);
}

void EntryScreen(void)
{
	char title[] = "TI-DICTIONARY";
	char version[] = "version 0.1";
	char author[] = "Kyle Littlefield";
	char contact[] = "lfield@oneworld.owt.com";
	
	clrscr();
	
	DrawStrCentered(15, title, F_8x10);
	DrawStrCentered(25, version, F_6x8);
	DrawStrCentered(75, author, F_4x6);
	DrawStrCentered(81, contact, F_4x6);
	ngetchx();
}

